---
title: XRSessionEvent
slug: Web/API/XRSessionEvent
tags:
  - API
  - AR
  - Event
  - Interface
  - Mixed
  - Reality
  - Reference
  - Session
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRSession
  - XRSessionEvent
  - augmented
---
<p>{{APIRef("WebXR Device API")}}</p>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a>'s <code><strong>XRSessionEvent</strong></code> interface describes an event which indicates the change of the state of an {{domxref("XRSession")}}.</span> These events occur, for example, when the session ends or the visibility of its context changes.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("XRSessionEvent.XRSessionEvent", "XRSessionEvent()")}}</dt>
 <dd>Creates and returns a new <code>XRSessionEvent</code> object configured using the specified {{domxref("XRSessionEventInit")}} object's values as available.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>In addition to properties inherited from its parent interface, {{domxref("Event")}}, <code>XRSessionEvent</code> provides the folllowing:</em></p>

<dl>
 <dt>{{domxref("XRSessionEvent.session", "session")}} {{ReadOnlyInline}}</dt>
 <dd>The {{domxref("XRSession")}} to which the event refers.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>While <code>XRSessionEvent</code> defines no methods, it inherits methods from its parent interface, {{domxref("Event")}}.</em></p>

<h2 id="Session_event_types">Session event types</h2>

<p><em>The following events are represented using the <code>XRSessionEvent</code> interface, and are permitted values for its <code>type</code> property.</em></p>

<dl>
 <dt>{{domxref("XRSession.end_event", "end")}}</dt>
 <dd>Fired at the session when it has ended, after being terminated by the application or the {{Glossary("user agent")}}.</dd>
 <dt>{{domxref("XRSession.visibilitychange_event", "visibilitychange")}}</dt>
 <dd>Fired at the session whenever its visibility state changes.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This example creates a listiener that watches for the visibility state of the session to change. It reacts by calling a function <code>mySessionVisible()</code> with a Boolean indicating whether or not the session is visible; this function might, for instance, spin up or reconfigure a worker that handles rendering the scene.</p>

<pre class="brush: js">xrSession.addEventListener("visibilitystate", e =&gt; {
  switch(e.session.visibilitystate) {
    case "visible":
    case "visible-blurred":
      mySessionVisible(true);
      break;
    case "hidden":
      mySessionVisible(false);
      break;
  }
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#xrsessionevent","XRSessionEvent")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSessionEvent")}}</div>
